import * as events from "events";
import * as etp from "etp";
export declare const WS_PROTOCOL = "energistics-tp";
export declare const NO_SESSION: string;
export declare var EINVALID_MESSAGE_TYPE: number;
export interface IChannelStore extends events.EventEmitter {
    addChannel(channelInfo: etp.Energistics.Datatypes.ChannelData.ChannelMetadataRecord, callback: (err, data) => void): any;
    putChannelValue(channel_id: string, value: etp.Energistics.Datatypes.ChannelData.DataItem, callback: (err, data) => void): any;
    describeChannels(uris: string[], callback: (err, data) => void): any;
    getChannelRange(channelInfo: any, startIndex: number, endIndex: number, callback: any): any;
}
export interface IStore extends events.EventEmitter {
    connect(connectionString: string): any;
    delete(uri: string): any;
    enum(uri: string, handler: (err, data) => void): any;
    get(uri: string, handler: (err, data) => void): any;
    notificationRequest(messageData: any, callback: () => void): any;
    put(messageData: any, handler: (err, data) => void): any;
}
export interface IStoreNotification {
    subscribe(request: etp.Energistics.Protocol.StoreNotification.NotificationRequest): any;
}
export interface ISuperStore extends IChannelStore, IStore, events.EventEmitter {
}
export interface ILogger {
    log(str: string): any;
}
export declare function String2Buffer(str: any): Uint8Array;
export declare function uriFromNative(object: any): any;
export declare function etpDate(dateIn?: Date): number;
export declare function encodeIndexValue(metadata: any, value: number): number;
export declare function decodeIndexValue(metadata: any, value: number): any;
