"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const url = require("url");
function dottedVersion(str) {
    var retVal = str[0];
    for (var i = 1; i < str.length; i++) {
        retVal += ".";
        retVal += str[i];
    }
    return retVal;
}
class EtpUri {
    constructor(_uri) {
        this._uri = _uri;
        this._url = url.parse(_uri);
        this._emluri = this._uri.match(/^eml:\/\/(.*?)\/((witsml|resqml|prodml|energyml)([0-9]+))(\/((obj_)(\w+))(\(([\-\w]+)\))?)?$/i);
    }
    eml(i) {
        return (this._emluri) ? this._emluri[i] : "";
    }
    get isWitsml() {
        return this.schemaFamily == "witsml";
    }
    get versionedFamily() {
        return this.eml(2);
    }
    get schemaFamily() {
        return this.eml(3);
    }
    get isUrn() {
        return this._url.protocol == "urn:";
    }
    get isUuid() {
        return this.isUrn && this._url.hostname == "uuid";
    }
    get isRoot() {
        return this._uri == "/";
    }
    get hasDataspace() {
        return this.eml(1) != "";
    }
    get objectType() {
        return this.eml(6);
    }
    get collection() {
        return this.eml(8);
    }
    get identifier() {
        return this.eml(10);
    }
    get dataSpace() {
        return this.eml(1);
    }
    get contentType() {
        return "application/x-" + this.schemaFamily + "+xml;version=" + dottedVersion(this.eml(4)) + ";type=" + this.objectType;
    }
}
exports.EtpUri = EtpUri;
//# sourceMappingURL=EtpUri.js.map