"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp_1 = require("etp");
const BaseHandler_1 = require("../common/BaseHandler");
var ChannelDataFrame = etp_1.Energistics.Protocol.ChannelDataFrame;
var PROTOCOL = etp_1.Energistics.Datatypes.Protocols;
class ChannelDataFrameProducer extends BaseHandler_1.BaseHandler {
    constructor(sessionManager) {
        super(sessionManager);
        this.sessionManager = sessionManager;
        this._role = "producer";
        this._protocol = 2;
    }
    handleMessage(messageHeader, messageBody) {
        if (messageHeader.protocol == PROTOCOL.ChannelDataFrame) {
            switch (messageHeader.messageType) {
                case ChannelDataFrame.MsgRequestChannelData:
                    try {
                    }
                    catch (exception) {
                        this.log(JSON.stringify(exception));
                        this.sessionManager.sendException(0, "Unable to describe URI: " + messageBody.uri, messageHeader.messageId);
                    }
                    break;
                default:
                    super.handleMessage(messageHeader, messageBody);
                    break;
            }
        }
        else {
            throw ("Unsupported protocol {" + messageHeader.protocol + "} in HistoricalProducer");
        }
    }
    onData(channelData) {
        var header = this.sessionManager.createHeader(PROTOCOL.ChannelDataFrame, ChannelDataFrame.MsgChannelDataFrameSet, 0, 0);
        this.sessionManager.send(header, channelData);
    }
    onMetadata(channelMetadata) {
        var header = this.sessionManager.createHeader(PROTOCOL.ChannelDataFrame, ChannelDataFrame.MsgChannelMetadata, 0);
        this.sessionManager.send(header, channelMetadata);
    }
}
exports.ChannelDataFrameProducer = ChannelDataFrameProducer;
//# sourceMappingURL=ChannelDataFrameProducer.js.map