"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp_1 = require("etp");
const BaseHandler_1 = require("../common/BaseHandler");
var Store = etp_1.Energistics.Protocol.Store;
var PROTOCOL = etp_1.Energistics.Datatypes.Protocols;
class StoreCustomer extends BaseHandler_1.BaseHandler {
    constructor(sessionManager) {
        super(sessionManager);
        this.sessionManager = sessionManager;
        this._role = "client";
        this._protocol = PROTOCOL.Store;
    }
    handleMessage(messageHeader, messageBody) {
        if (messageHeader.protocol == PROTOCOL.Store) {
            switch (messageHeader.messageType) {
                case Store.MsgObject:
                    this.emit("object", messageHeader, messageBody);
                    break;
                default:
                    super.handleMessage(messageHeader, messageBody);
            }
        }
        else {
            throw ("Unsupported protocol {" + messageHeader.protocol + "} in DiscoveryStore");
        }
    }
    get(uri) {
        this.log("Getting " + uri + " from store");
        var header = this.sessionManager.createHeader(PROTOCOL.Store, Store.MsgGetObject, 0);
        this.sessionManager.send(header, { uri: uri });
    }
    put(uri) {
        this.log("Getting " + uri + " from store");
        var header = this.sessionManager.createHeader(PROTOCOL.Store, Store.MsgPutObject, 0);
        this.sessionManager.send(header, { uri: uri });
    }
    deleteObject(uris) {
        this.log("Deleting " + uris + " from store");
        var header = this.sessionManager.createHeader(PROTOCOL.Store, Store.MsgDeleteObject, 0);
        this.sessionManager.send(header, { uri: uris });
    }
}
exports.StoreCustomer = StoreCustomer;
//# sourceMappingURL=StoreCustomer.js.map