"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp_1 = require("etp");
const BaseHandler_1 = require("../common/BaseHandler");
var StoreNotification = etp_1.Energistics.Protocol.StoreNotification;
var PROTOCOL = etp_1.Energistics.Datatypes.Protocols;
class StoreNotificationCustomer extends BaseHandler_1.BaseHandler {
    constructor(sessionManager) {
        super(sessionManager);
        this.sessionManager = sessionManager;
        this.requests = [];
        this._role = "customer";
        this._protocol = PROTOCOL.StoreNotification;
    }
    handleMessage(messageHeader, messageBody) {
        if (messageHeader.protocol == PROTOCOL.StoreNotification) {
            switch (messageHeader.messageType) {
                case StoreNotification.MsgChangeNotification:
                    this.log("Received change notification: " + JSON.stringify(messageBody));
                    this.emit('change', { header: messageHeader, body: messageBody });
                    break;
                case StoreNotification.MsgDeleteNotification:
                    this.log("Received delete notification: " + JSON.stringify(messageBody));
                    this.emit('delete', { header: messageHeader, body: messageBody });
                    break;
                default:
                    super.handleMessage(messageHeader, messageBody);
            }
        }
        else {
            throw ("Unsupported protocol {" + messageHeader.protocol + "} in StoreNotification");
        }
    }
    notificationRequest(message) {
        var header = this.sessionManager.createHeader(PROTOCOL.StoreNotification, StoreNotification.MsgNotificationRequest, 0);
        this.requests.push({ header: header, body: message });
        this.sessionManager.send(header, message);
    }
}
exports.StoreNotificationCustomer = StoreNotificationCustomer;
//# sourceMappingURL=StoreNotificationCustomer.js.map