import events = require("events");
import { IStore } from "../common/EnergisticsCommons";
import { Energistics } from "etp";
export declare class PerfMonProvider extends events.EventEmitter {
    private sessionId;
    constructor(sessionId: string, configuration: any);
    newChannelId: any;
    running: boolean;
    server: string;
    activeChannels: any[];
    lastValue: any[];
    config: any;
    nextRow(err: any, data: any): void;
    startAllChannels(): void;
    startStreaming(channels: Energistics.Datatypes.ChannelData.ChannelStreamingInfo[]): void;
    stopStreaming(channels: any): void;
    stop(): void;
    describe(msg: any): void;
    toChannelMetadata(uri: any): {
        channelUri: any;
        channelId: any;
        indexes: {
            indexType: string;
            description: string;
            uri: {
                string: string;
            };
            direction: string;
            mnemonic: string;
            indexID: number;
            uom: string;
            datum: any;
            customData: {};
        }[];
        dataType: string;
        uom: string;
        startIndex: any;
        endIndex: any;
        channelName: any;
        description: any;
        status: string;
        contentType: any;
        source: any;
        measureClass: string;
        uuid: any;
    };
}
export declare class PerfStore extends events.EventEmitter implements IStore {
    constructor(connectString: string);
    connect(): void;
    enum(uriString: string, callback: (err, data) => void): void;
    get(uriString: string, callback: (err, data) => void): void;
    getHistory(uri: string, callback: (err, data) => void): void;
    put(obj: Energistics.Datatypes.Object.DataObject): void;
    putChannelValue(uriChannel: any, index: any, value: any): void;
    delete(uriString: string): void;
    on_connect(err: any, db: any): void;
    notificationRequest(messageData: any, callback: any): void;
}
