"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const witsml = require("../lib/common/WitsmlHelper");
var argv = require('optimist')
    .usage("\nWITSML Data Loader for ETP and Node.js")
    .default({
    databaseConnectString: 'mongodb://localhost:27017/test',
    schemaModule: "witsml1411",
    storeModule: '../lib/providers/MongoStore',
    pivot: false,
    headerOnly: false,
    dryRun: false,
    fileName: "H:\\data\\energyml\\WITSMLSIG_SampleDataSet_1411\\DemoWell01\\Wellbore A\\log_L-499007-Time_segment001.xml",
}).argv;
if (argv.help) {
    require('optimist').showHelp();
    process.exit(0);
}
function do_work(store) {
    console.log(argv.fileName);
    var loader = new witsml.FileLoader(store, argv);
    loader.headerOnly = argv.headerOnly;
    loader.on('ready', function () {
        loader.load_doc(argv.fileName);
    });
    loader.on('done', function () {
        if (process.send) {
            process.send({ dataObjects: 1, rows: loader.rows, points: loader.points, channels: loader.channels, stations: loader.stations, nullValues: loader.nullValues });
        }
        else {
            console.dir({ dataObjects: 1, rows: loader.rows, points: loader.points, channels: loader.channels, stations: loader.stations, nullValues: loader.nullValues });
        }
        process.exit(0);
    });
    loader.start();
}
if (argv.dryRun != 'true') {
    var storeClass = require(argv.storeModule);
    var store = new storeClass(argv);
    store.on("connect", function () {
        do_work(store);
    });
}
else {
    do_work(null);
}
//# sourceMappingURL=loadOne.js.map