"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const events = require("events");
class BaseHandler extends events.EventEmitter {
    constructor(logger) {
        super();
        this.logger = logger;
        this._role = "";
        this._protocol = -1;
    }
    get role() { return this._role; }
    get protocol() { return this._protocol; }
    start() { }
    stop() { }
    handleMessage(messageHeader, messageBody) {
        switch (messageHeader.messageType) {
            case 0:
                console.log("Received protocol 1 start message.");
                this.start();
                break;
            case 1000:
                this.logger.log(messageBody);
                break;
            case 1001:
                this.logger.log("Received Acknowledge.");
                break;
            default:
                throw ("Unsupported message {" + messageHeader.messageType + "}");
        }
    }
    log(str) {
        this.logger.log(str);
    }
}
exports.BaseHandler = BaseHandler;
//# sourceMappingURL=BaseHandler.js.map