import * as events from "events";
import { BaseHandler } from "./BaseHandler";
import { SchemaCache } from "etp";
import { IStore } from "./EnergisticsCommons";
export declare class ETPCore extends events.EventEmitter {
    connection: any;
    name: string;
    schemas: any[];
    config: any;
    messageId: number;
    schemaCache: SchemaCache;
    sessionId: string;
    binary: boolean;
    handlers: BaseHandler[];
    store: IStore;
    stats: {
        blocks: number;
        rows: number;
        dataPoints: number;
        bytesSent: number;
        bytesReceived: number;
        messagesSent: number;
        messagesReceived: number;
        connectDate: Date;
        firstDataBlock: any;
        lastDataBlock: any;
    };
    constructor(configuration: any, store?: IStore);
    acknowledge(messageId: number): void;
    closeSession(): void;
    createHeader(protocol: any, messageType: any, correlationId?: number, messageFlags?: number): {
        protocol: any;
        messageType: any;
        messageId: number;
        correlationId: number;
        messageFlags: number;
    };
    isInSession(): boolean;
    handleMessage(messageHeader: any, messageBody: any): void;
    log(message: string): void;
    onCloseSession(header: any, message: any): void;
    onAcknowledge(header: any, message: any): void;
    onException(header: any, message: any): void;
    registerHandler(id: number, handler: BaseHandler): BaseHandler;
    send(header: any, message: any): void;
    sendException(errorCode: number, errorMessage: string, correlationId: number): void;
}
