"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp = require("etp");
exports.WS_PROTOCOL = "energistics-tp";
exports.NO_SESSION = "";
exports.EINVALID_MESSAGE_TYPE = 3;
function String2Buffer(str) {
    var buf = new ArrayBuffer(str.length);
    var bufView = new Uint8Array(buf);
    for (var i = 0, strLen = str.length; i < strLen; i++) {
        bufView[i] = str.charCodeAt(i);
    }
    return bufView;
}
exports.String2Buffer = String2Buffer;
function uriFromNative(object) {
    var retVal = new etp.Energistics.Datatypes.Object.Resource();
    if (object.TYPE_NAME) {
        var pattern = object.TYPE_NAME.match(/^([\w+]ml)(\d+)\.Obj(\w+)$/i);
    }
    return null;
}
exports.uriFromNative = uriFromNative;
function etpDate(dateIn = null) {
    dateIn || (dateIn = new Date());
    return dateIn.valueOf() * 1000;
}
exports.etpDate = etpDate;
function encodeIndexValue(metadata, value) {
    if (!value)
        return null;
    switch (metadata.indexType) {
        case "Time":
        case "ElapsedTime":
            return value * 1000;
        default:
            return value * Math.pow(10, metadata.scale);
    }
}
exports.encodeIndexValue = encodeIndexValue;
function decodeIndexValue(metadata, value) {
    if (!value)
        return null;
    switch (metadata.indexType || metadata) {
        case "Time":
        case "ElapsedTime":
            return new Date(value / 1000);
        default:
            return value / Math.pow(10, metadata.scale);
    }
}
exports.decodeIndexValue = decodeIndexValue;
//# sourceMappingURL=EnergisticsCommons.js.map