"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class EtpContentType {
    constructor(_contentType) {
        this._contentType = _contentType;
        this._m = this._contentType.match(/^application\/x-(witsml|resqml|prodml)\+xml;version=([0-9.]+);type=(obj_\w+)$/i);
    }
    get hasPlural() {
        return ((this._m[2][0] == "1") && this._m[1] != "resqml");
    }
    get schemaFamily() {
        return this._m[1];
    }
    get version() {
        return this._m[2];
    }
    get dataType() {
        return this._m[3];
    }
    get pluralName() {
        return this._m[3].substr(4) + "s";
    }
    get singularName() {
        return this._m[3].substr(4);
    }
    get valid() {
        return this._m != null;
    }
    get contentType() {
        return this._contentType;
    }
}
exports.EtpContentType = EtpContentType;
//# sourceMappingURL=EtpContentType.js.map