import events = require("events");
export declare class LogLoader {
    private store;
    private log;
    private parentLoader;
    constructor(store: any, log: any, parentLoader: any);
    headerOnly: boolean;
    logData: any;
    logCurveInfo: any[];
    channelCount: number;
    channelsRegistered: number;
    pivot: boolean;
    curveMap: {};
    channelMetadata: any[];
    channelData: {};
    frameData: any[];
    dataTypeFromCurveInfo(info: any): any;
    channelDataMap(): {};
    logToChannelIndex(log: any): any;
    curveInfoToChannelMetadata(log: any, info: any, theIndex: any): {
        channelUri: string;
        contextUri: string;
        indexes: any[];
        dataType: any;
        uom: any;
        startIndex: any;
        endIndex: any;
        channelName: any;
        description: any;
        status: string;
        source: any;
        measureClass: string;
    };
    parseLogCurves(): void;
    insertLogCurves(): void;
    loadLog(): void;
}
export declare class TrajectoryLoader {
    private store;
    private trajectory;
    private parentLoader;
    constructor(store: any, trajectory: any, parentLoader: any);
    stations: any[];
    loadTrajectory(): void;
}
export declare class FileLoader extends events.EventEmitter {
    private store;
    private config;
    constructor(store: any, config: any);
    headerOnly: boolean;
    messageData: any;
    dataObject: any;
    log: LogLoader;
    trajectory: TrajectoryLoader;
    points: number;
    rows: number;
    channels: number;
    stations: number;
    nullValues: number;
    onLoadComplete(): void;
    start(): void;
    handleLog(err: any, result: any): void;
    handleTrajectory(err: any, result: any): void;
    load_doc(file: any): void;
}
