"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp_1 = require("etp");
const BaseHandler_1 = require("../common/BaseHandler");
var ChannelDataFrame = etp_1.Energistics.Protocol.ChannelDataFrame;
var PROTOCOL = etp_1.Energistics.Datatypes.Protocols;
class ChannelDataFrameConsumer extends BaseHandler_1.BaseHandler {
    constructor(sessionManager) {
        super(sessionManager);
        this.sessionManager = sessionManager;
        this._role = "consumer";
        this._protocol = 2;
    }
    handleMessage(messageHeader, messageBody) {
        if (messageHeader.protocol == PROTOCOL.ChannelDataFrame) {
            switch (messageHeader.messageType) {
                case ChannelDataFrame.MsgChannelMetadata:
                    this.emit('metadata', messageBody);
                    break;
                case ChannelDataFrame.MsgChannelDataFrameSet:
                    this.emit('data', messageBody);
                    break;
                default:
                    super.handleMessage(messageHeader, messageBody);
            }
        }
        else {
            throw ("Unsupported protocol {" + messageHeader.protocol + "} in HistoricalConsumer");
        }
    }
    requestChannelData(subscription) {
        var header = this.sessionManager.createHeader(PROTOCOL.ChannelDataFrame, ChannelDataFrame.MsgRequestChannelData, 0, 0);
        this.sessionManager.send(header, { uri: subscription, fromIndex: null, toIndex: null });
    }
}
exports.ChannelDataFrameConsumer = ChannelDataFrameConsumer;
//# sourceMappingURL=ChannelDataFrameConsumer.js.map