"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp_1 = require("etp");
const BaseHandler_1 = require("../common/BaseHandler");
var Discovery = etp_1.Energistics.Protocol.Discovery;
var PROTOCOL = etp_1.Energistics.Datatypes.Protocols;
class DiscoveryCustomer extends BaseHandler_1.BaseHandler {
    constructor(sessionManager) {
        super(sessionManager);
        this.sessionManager = sessionManager;
        this._role = "customer";
        this._protocol = PROTOCOL.Discovery;
    }
    handleMessage(messageHeader, messageBody) {
        if (messageHeader.protocol == PROTOCOL.Discovery) {
            switch (messageHeader.messageType) {
                case Discovery.MsgGetResourcesResponse:
                    this.emit("resource", messageHeader, messageBody);
                    break;
                default:
                    super.handleMessage(messageHeader, messageBody);
            }
        }
        else {
            throw ("Unsupported protocol {" + messageHeader.protocol + "} in DiscoveryCustomer");
        }
    }
    get(uri) {
        var header = this.sessionManager.createHeader(PROTOCOL.Discovery, Discovery.MsgGetResources, 0);
        this.sessionManager.send(header, { uri: uri });
        return header.messageId;
    }
}
exports.DiscoveryCustomer = DiscoveryCustomer;
//# sourceMappingURL=DiscoveryCustomer.js.map