"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const etp_1 = require("etp");
const BaseHandler_1 = require("../common/BaseHandler");
var Store = etp_1.Energistics.Protocol.Store;
var PROTOCOL = etp_1.Energistics.Datatypes.Protocols;
function object_callback(err, data) {
    if (err) {
        this.handler.log(err);
    }
    else if (data) {
        var header = this.handler.sessionManager.createHeader(PROTOCOL.Store, Store.MsgObject, this.header.messageId);
        this.handler.sessionManager.send(header, data);
    }
    else {
        this.handler.sessionManager.sendException(-1, "Uri [" + this.body.uri + "] not found", this.header.messageId);
    }
}
class StoreStore extends BaseHandler_1.BaseHandler {
    constructor(sessionManager, store) {
        super(sessionManager);
        this.sessionManager = sessionManager;
        this.store = store;
        this.store = store;
        this._role = "store";
        this._protocol = PROTOCOL.Store;
    }
    handleMessage(messageHeader, messageBody) {
        if (messageHeader.protocol == PROTOCOL.Store) {
            switch (messageHeader.messageType) {
                case Store.MsgGetObject:
                    this.log("Get " + messageBody.uri + " from store.");
                    this.store.get(messageBody.uri, object_callback.bind({ handler: this, header: messageHeader, body: messageBody }));
                    break;
                case Store.MsgPutObject:
                    this.store.put({ header: messageHeader, body: messageBody }, function (err, result) { });
                    break;
                case Store.MsgDeleteObject:
                    messageBody.uri.forEach(this.store.delete, this.store);
                    break;
                default:
                    super.handleMessage(messageHeader, messageBody);
            }
        }
        else {
            throw ("Unsupported protocol {" + messageHeader.protocol + "} in StoreStore");
        }
    }
}
exports.StoreStore = StoreStore;
//# sourceMappingURL=StoreStore.js.map